#ifndef PREFS_DOS_H
#define PREFS_DOS_H
/*
**  $VER: dos.h 53.21 (29.9.2013)
**
**  File format for DOS preferences
**
**  Copyright (C) 1985-2005 Hyperion Entertainment VOF and Amiga, Inc.
**      All Rights Reserved
**
**  Copyright (c) 2010 Hyperion Entertainment CVBA.
**      All Rights Reserved.
*/

/*****************************************************************************/

#ifndef   EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef   LIBRARIES_IFFPARSE_H
#include <libraries/iffparse.h>
#endif

/*****************************************************************************/

#ifdef __cplusplus
#ifdef __USE_AMIGAOS_NAMESPACE__
namespace AmigaOS {
#endif
extern "C" {
#endif

#ifdef __GNUC__
   #ifdef __PPC__
    #pragma pack(2)
   #endif
#elif defined(__VBCC__)
   #pragma amiga-align
#endif

/*****************************************************************************/


#define ID_DOSP MAKE_ID('D','O','S','P')


struct DOSPrefs
{
    LONG dp_FHBufferSize;       /* size in bytes for all FileHandle buffers. */
    LONG dp_MinProcStack;       /* minimum stack bytes for all processes */
    LONG dp_WarnWaitTime;       /* number of seconds to wait between warnings. */
    LONG dp_WarnPostTime;       /* number of seconds to post warning for.  */
    LONG dp_WildStar;           /* BOOLEAN - see doscontrol  */
    LONG dp_AssignMount;        /* BOOLEAN - see errorreport()  */
    LONG dp_BootCliFontSize;    /* Set to: TOPAZ_EIGHTY or TOPAZ_SIXTY (8 or 9) */
                                /* The define for this is in intuition/preferences.h */
    LONG dp_BootCliCloseGadget; /* BOOLEAN - see doscontrol */
    LONG dp_Reserved[6];        /* reserved for future expansion.  */
};


/*****************************************************************************/

#ifdef __GNUC__
   #ifdef __PPC__
    #pragma pack()
   #endif
#elif defined(__VBCC__)
   #pragma default-align
#endif


#ifdef __cplusplus
}
#ifdef __USE_AMIGAOS_NAMESPACE__
}
#endif
#endif

/*****************************************************************************/

#endif /* PREFS_DOS_H */
