#ifndef PROTO_GRAPHICS_H
#define PROTO_GRAPHICS_H

/*
**	$VER: graphics.h 53.21 (29.9.2013)
**
**	Prototype/inline/pragma header file combo
**
**	Copyright (c) 2010 Hyperion Entertainment CVBA.
**	All Rights Reserved.
*/

#ifndef GRAPHICS_GFX_H
#include <graphics/gfx.h>
#endif
#ifndef GRAPHICS_DISPLAYINFO_H
#include <graphics/displayinfo.h>
#endif
#ifndef GRAPHICS_GELS_H
#include <graphics/gels.h>
#endif
#ifndef GRAPHICS_RASTPORT_H
#include <graphics/rastport.h>
#endif
#ifndef GRAPHICS_VIEW_H
#include <graphics/view.h>
#endif
#ifndef GRAPHICS_COPPER_H
#include <graphics/copper.h>
#endif
#ifndef GRAPHICS_CLIP_H
#include <graphics/clip.h>
#endif
#ifndef GRAPHICS_REGIONS_H
#include <graphics/regions.h>
#endif
#ifndef GRAPHICS_SCALE_H
#include <graphics/scale.h>
#endif
#ifndef GRAPHICS_SPRITE_H
#include <graphics/sprite.h>
#endif
#ifndef GRAPHICS_TEXT_H
#include <graphics/text.h>
#endif
#ifndef HARDWARE_BLIT_H
#include <hardware/blit.h>
#endif

/****************************************************************************/

#ifndef __NOLIBBASE__
 #ifndef __USE_BASETYPE__
  extern struct Library * GfxBase;
 #else
  extern struct GfxBase * GfxBase;
 #endif /* __USE_BASETYPE__ */
#endif /* __NOLIBBASE__ */

/****************************************************************************/

#ifdef __amigaos4__
 #include <interfaces/graphics.h>
 #ifdef __USE_INLINE__
  #include <inline4/graphics.h>
 #endif /* __USE_INLINE__ */
 #ifndef CLIB_GRAPHICS_PROTOS_H
  #define CLIB_GRAPHICS_PROTOS_H 1
 #endif /* CLIB_GRAPHICS_PROTOS_H */
 #ifndef __NOGLOBALIFACE__
  extern struct GraphicsIFace *IGraphics;
 #endif /* __NOGLOBALIFACE__ */
#else /* __amigaos4__ */
 #ifndef CLIB_GRAPHICS_PROTOS_H
  #include <clib/graphics_protos.h>
 #endif /* CLIB_GRAPHICS_PROTOS_H */
 #if defined(__GNUC__)
  #ifndef __PPC__
   #include <inline/graphics.h>
  #else
   #include <ppcinline/graphics.h>
  #endif /* __PPC__ */
 #elif defined(__VBCC__)
  #ifndef __PPC__
   #include <inline/graphics_protos.h>
  #endif /* __PPC__ */
 #else
  #include <pragmas/graphics_pragmas.h>
 #endif /* __GNUC__ */
#endif /* __amigaos4__ */

/****************************************************************************/

#endif /* PROTO_GRAPHICS_H */
